--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
  me._class = #WebFrame
  -- implement interface
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #WebFrame
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addObjectToJavaScriptWindowObject (string,ObjectID)
on addObjectToJavaScriptWindowObject (me,p1,p2)
  if ilk(p2)=#instance then p2 = p2._id
  $.Qt._qx.callObject(me._id,#addObjectToJavaScriptWindowObject,p1,p2)
end

-- addWidgetToJavaScriptWindowObject (string,WidgetID)
on addWidgetToJavaScriptWindowObject (me,p1,p2)
  if ilk(p2)=#instance then p2 = p2._id
  $.Qt._qx.callObject(me._id,#addWidgetToJavaScriptWindowObject,p1,p2)
end

-- contentsSize () -> int
on contentsSize (me)
  return $.Qt._qx.callObject(me._id,#contentsSize)
end

-- evaluateJavaScript (string) -> string
on evaluateJavaScript (me,p1)
put p1
  return $.Qt._qx.callObject(me._id,#evaluateJavaScript,p1)
end

-- hasFocus () -> bool
on hasFocus (me)
  return $.Qt._qx.callObject(me._id,#hasFocus)
end

-- load (string url)
on load (me,p1)
  $.Qt._qx.callObject(me._id,#load,p1)
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- render (PainterID)
on render (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	put "RENDER", p1
  $.Qt._qx.callObject(me._id,#render,p1)
end

-- setContent (string,*string,string)
on setContent (me,p1,p2,p3)
  $.Qt._qx.callObject(me._id,#setContent,p1,p2,p3)
end

-- setFocus ()
on setFocus (me)
  $.Qt._qx.callObject(me._id,#setFocus)
end

-- setHtml (string,*string)
on setHtml (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setHtml,p1,p2)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setTextSizeMultiplier (float)
on setTextSizeMultiplier (me,p1)
  $.Qt._qx.callObject(me._id,#setTextSizeMultiplier,p1)
end

-- setUrl (string url)
on setUrl (me,p1)
  $.Qt._qx.callObject(me._id,#setUrl,p1)
end

-- setZoomFactor (float)
on setZoomFactor (me,p1)
  $.Qt._qx.callObject(me._id,#setZoomFactor,p1)
end

-- textSizeMultiplier () -> float
on textSizeMultiplier (me)
  return $.Qt._qx.callObject(me._id,#textSizeMultiplier)
end

-- toHtml () -> string
on toHtml (me)
  return $.Qt._qx.callObject(me._id,#toHtml)
end

-- toPlainText () -> string
on toPlainText (me)
  return $.Qt._qx.callObject(me._id,#toPlainText)
end

-- url () -> string
on url (me)
  return $.Qt._qx.callObject(me._id,#url)
end

-- zoomFactor () -> float
on zoomFactor (me)
  return $.Qt._qx.callObject(me._id,#zoomFactor)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- javaScriptWindowObjectCleared
on javaScriptWindowObjectCleared(me,id)
  me._detach(#javaScriptWindowObjectCleared,id)
end

-- loadFinished -> bool
on loadFinished(me,id,p1)
  me._detach(#loadFinished,id,p1)
end

-- loadStarted
on loadStarted(me,id)
  me._detach(#loadStarted,id)
end

-- pageChanged
on pageChanged(me,id)
  me._detach(#pageChanged,id)
end

-- titleChanged -> string
on titleChanged(me,id,p1)
  me._detach(#titleChanged,id,p1)
end

-- urlChanged -> string
on urlChanged(me,id,p1)
  me._detach(#urlChanged,id,p1)
end

