--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #DateEdit
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #DateEdit
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- date () -> string
on date (me)
  return $.Qt._qx.callWidget(me._id,#date)
end

-- displayFormat () -> string
on displayFormat (me)
  return $.Qt._qx.callWidget(me._id,#displayFormat)
end

-- setDate (int,int,int)
on setDate (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#setDate,p1,p2,p3)
end

-- setDisplayFormat (string)
on setDisplayFormat (me,p1)
  $.Qt._qx.callWidget(me._id,#setDisplayFormat,p1)
end

-- SetMaximumDate (int,int,int)
on SetMaximumDate (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#SetMaximumDate,p1,p2,p3)
end

-- SetMinimumDate (int,int,int)
on SetMinimumDate (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#SetMinimumDate,p1,p2,p3)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- dateTimeChanged -> string
on dateTimeChanged(me,id,p1)
  me._detach(#dateTimeChanged,id,p1)
end

