--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Label
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #Label
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- setAlignment (int)
on setAlignment (me,p1)
  $.Qt._qx.callWidget(me._id,#setAlignment,p1)
end

-- setBuddy (int)
on setBuddy (me,p1)
  $.Qt._qx.callWidget(me._id,#setBuddy,p1)
end

-- setImage (int|image|string)
on setImage (me,p1)
  $.Qt._qx.callWidget(me._id,#setImage,p1)
end

-- setIndent (int)
on setIndent (me,p1)
  $.Qt._qx.callWidget(me._id,#setIndent,p1)
end

-- setMargin (int)
on setMargin (me,p1)
  $.Qt._qx.callWidget(me._id,#setMargin,p1)
end

-- setOpenExternalLinks (bool)
on setOpenExternalLinks (me,p1)
  $.Qt._qx.callWidget(me._id,#setOpenExternalLinks,p1)
end

-- setPicture (int)
on setPicture (me,p1)
  $.Qt._qx.callWidget(me._id,#setPicture,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- setTextFormat (int)
on setTextFormat (me,p1)
  $.Qt._qx.callWidget(me._id,#setTextFormat,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callWidget(me._id,#text)
end

-- setWordWrap (bool)
on setWordWrap (me,p1)
  $.Qt._qx.callWidget(me._id,#setWordWrap,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- linkActivated -> string
on linkActivated(me,id,p1)
  me._detach(#linkActivated,id,p1)
end

-- linkHovered -> string
on linkHovered(me,id,p1)
  me._detach(#linkHovered,id,p1)
end

