--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID,int,int)
on new (me,p1,p2,p3)
  me._class = #MainWindow
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1,p2,p3)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #MainWindow
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addDockWidget (int,DockWidgetID)
on addDockWidget (me,p1,p2)
  if ilk(p2)=#instance then p2 = p2._id
  $.Qt._qx.callWidget(me._id,#addDockWidget,p1,p2)
end

-- addToolBar (toolBarID,*area)
on addToolBar (me,p1,p2)
  if ilk(p1)=#instance then p1 = p1._id
  if the paramCount>2 then
  	$.Qt._qx.callWidget(me._id,#addToolBar,p1,p2)
  else
  	$.Qt._qx.callWidget(me._id,#addToolBar,p1)
  end if
end

-- addToolBarBreak (int)
on addToolBarBreak (me,p1)
  $.Qt._qx.callWidget(me._id,#addToolBarBreak,p1)
end

-- getMenuBar () -> menuBarID
on getMenuBar (me)
  obj = $.Qt.menuBar._make($.Qt._qx.callWidget(me._id,#getMenuBar))
  me._children.add(obj)
  return obj
end

-- removeDockWidget (DockWidgetID)
on removeDockWidget (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#removeDockWidget,p1)
end

-- setCentralWidget (WidgetID)
on setCentralWidget (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setCentralWidget,p1)
end

-- setMenuBar (MenuBarID)
on setMenuBar (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setMenuBar,p1)
end

-- setStatusBar (StatusBarID)
on setStatusBar (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setStatusBar,p1)
end

-- setToolButtonStyle (int)
on setToolButtonStyle (me,p1)
  $.Qt._qx.callWidget(me._id,#setToolButtonStyle,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

